interface Expr{
    public int eval();
}

class CstI implements Expr{
    private int val;

    public CstI(int val){
	this.val = val;
    }

    public int eval(){
	return val;
    }
}

class Prim implements Expr{
    private String op;
    private Expr arg1;
    private Expr arg2;

    /* aggiungere costruttore  */

    /* completare metodo eval */
    public int eval(){
	if (op.equals("+")) return arg1.eval() + arg2.eval();
	else throw new IllegalArgumentException("Unknown operator in Prim.eval: " + op);
    }
}

public class Test1{
    public static void main(String [] args){
	Expr e1 = new CstI(17);

	//     Expr e2 = new Prim("+", new CstI(3), new CstI(4));

	//     Expr e3 = new Prim("+", new Prim("*", new CstI(7), new CstI(9)), new CstI(5));
	
	System.out.println(e1.eval());
	//     System.out.println(e2.eval());
	//	System.out.println(e3.eval());
    }
}

    
